<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="BallotDocumentationEdit" class="parameter-edit" [class.read-only]="readOnly">
  <mat-card-header>
    <mat-card-title>{{'parameters.ballot-documentation.edit.title' | translate}}</mat-card-title>
    <mat-card-subtitle fxLayout="row" fxLayoutAlign="space-between">
      <span>{{'parameters.ballot-documentation.edit.subtitle' | translate}}</span>
      <span *ngIf="!readOnly">{{'global.forms.fields.required' | translate}}</span>
    </mat-card-subtitle>
  </mat-card-header>
  <mat-card-content class="no-padding">


    <ng-container *roles="['ADD_BALLOT_DOCUMENTATION']">
      <div *ngIf="allBallots && allBallots.length == 0 " class="parameter-input"
           id="no-repository-file">
        {{'parameters.ballot-documentation.edit.repository-file-required' | translate}}
      </div>


      <div fxLayout fxLayoutGap="25px" class="parameter-input" id="ballotDocumentationInputBox"
           *ngIf="allBallots && allBallots.length > 0 && !readOnly">
        <form [formGroup]="form" novalidate>
          <div fxLayout fxLayoutGap="25px">
            <mat-form-field class="form-field-ballot-id">
              <mat-select
                (selectionChange)="updatePossibleLanguages()"
                [placeholder]="'parameters.ballot-documentation.edit.form.fields.ballot.placeholder' | translate"
                formControlName="ballotId" required>
                <mat-option *ngFor="let ballotId of possibleBallots" [value]="ballotId">
                  {{ballotId }}
                </mat-option>
              </mat-select>
              <mat-error>
                <default-errors [fieldName]="'ballotId'" [form]="form"></default-errors>
              </mat-error>
            </mat-form-field>


            <mat-form-field class="form-field-language">
              <mat-select
                (selectionChange)="updatePossibleBallots()"
                [placeholder]="'parameters.ballot-documentation.edit.form.fields.language.placeholder' | translate"
                formControlName="language" required>
                <mat-option *ngFor="let lang of possibleLanguages" [value]="lang.value">
                  {{lang.labelKey | translate}}
                </mat-option>
              </mat-select>
              <mat-error>
                <default-errors [fieldName]="'language'" [form]="form"></default-errors>
              </mat-error>
            </mat-form-field>

            <mat-form-field class="form-field-localized-label">
              <input matInput name="localizedLabel" formControlName="localizedLabel"
                     placeholder="{{'parameters.ballot-documentation.edit.form.fields.localized-label.placeholder' | translate}}"
                     required>
              <mat-error>
                <default-errors [fieldName]="'localizedLabel'" [form]="form"></default-errors>
              </mat-error>
            </mat-form-field>
          </div>
          <mat-error>
            <span *ngIf="form.hasError('labelExists')">{{duplicateFile}}</span>
          </mat-error>

        </form>

        <upload-input fxFlex="auto"
                      placeholder="parameters.ballot-documentation.edit.form.fields.input-file.placeholder"
                      [uploadUrl]="uploadUrl"
                      [checkBeforeUpload]="checkBeforeUpload()"
                      fileAccept=".pdf"
                      uploadIcon="file_upload"
                      uploadText="global.actions.import"
                      progressText="global.upload-progress"
                      (uploadDone)="processUploadResult($event)">
        </upload-input>


      </div>
    </ng-container>


    <mat-table [hidden]="!ballotDocumentations || ballotDocumentations.length === 0"
               [dataSource]="dataSource" matSort id="ballotDocumentationList">

      <ng-container matColumnDef="managementEntity">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          {{"parameters.ballot-documentation.table.header.management-entity" | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <div>
            {{element.managementEntity}}
          </div>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="ballotId">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          {{"parameters.ballot-documentation.table.header.ballot" | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <div>
            {{element.ballotId}}
          </div>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="file">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          {{"parameters.ballot-documentation.table.header.file" | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <a href="#" (click)="download($event, element)">{{element.fileName}}</a>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="localizedLabel">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          {{"parameters.ballot-documentation.table.header.localized-label" | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          {{element.localizedLabel}}
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="language">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          {{"parameters.ballot-documentation.table.header.language" | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          {{element.language}}
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="delete">
        <mat-header-cell *matHeaderCellDef>
          {{"parameters.ballot-documentation.table.header.delete" | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <button *ngIf="canDeleteFile(element)" mat-icon-button color="accent" class="btn-delete"
                  (click)="deleteFile(element)">
            <mat-icon>clear</mat-icon>
          </button>
        </mat-cell>
      </ng-container>

      <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
      <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
    </mat-table>

  </mat-card-content>
</mat-card>
